<?php

namespace Home\Controller;

use Think\Controller;

class PushwarnController extends Controller
{
    /**
     * 请求模板接口
     * @param $url 传输路径
     * @param string $data 数据
     * @return bool|string
     */
    public function curl($url, $data = '')
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; MSIE 5.01; Windows NT 5.0)');
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $info = curl_exec($ch);
        if (curl_errno($ch)) {
            return 'Errno' . curl_error($ch);
        } else {
            return $info;
        }
        curl_close($ch);
    }

    /**
     * [array_column1 ] 多维数组改成关联数组转字符串，
     * @param  $rows [description]必需。多维数组。
     * @param  [type] $column_key [description]必需。可以是索引数组的列的整数索引，或者是关联数组的列的字符串键值。
     * @param  [type] $index_key  [description]可选。用作返回数组的索引/键的列。
     * @return [type]             [description]（两个参数）返回用逗号分割的字符串，（三个参数）返回以第三个参数为列的索引数组
     */
    public function array_column1($rows, $column_key, $index_key = null)
    {
        $data = array();
        if (empty($index_key)) {
            foreach ($rows as $row) {
                $data[] = $row[$column_key];
            }
            $data = implode(",", $data);
        } else {
            foreach ($rows as $row) {
                $data[$row[$index_key]] = $row[$column_key];
            }
        }
        return $data;
    }


    /**
     * @param $access_token token令牌
     * @param $openid 微信openid
     * @param $address 报警地址
     * @param $deviceid 设备编号
     * @param $type 报警类型
     * @param $time 报警时间
     * @param $remark 备注
     * @param $url 查看详情url路径
     * @return mixed
     */
    public function SendDeviceAlarm($access_token, $openid, $address, $deviceid, $type, $time, $remark, $url)
    {
        $data = array(
            "touser" => $openid,
            "template_id" => "FmrNuMzgh0E8bWg1j8a2R3zTmRarHYtZ72TSzPrF9Iw",
            "url" => $url,
            "data" => array(
                "first" => array(
                    "value" => $address,
                    "color" => "#44b549"
                ),
                "keyword1" => array(
                    "value" => $deviceid,
                    "color" => "#173177"
                ),
                "keyword2" => array(
                    "value" => $type,
                    "color" => "#173177"
                ),
                "keyword3" => array(
                    "value" => $time,
                    "color" => "#173177"
                ),
                "remark" => array(
                    "value" => $remark,
                    "color" => "#aaaaaa"
                )
            )
        );
        $data = json_encode($data);
        $QUEST_URL = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" . $access_token;
        $res = $this->curl($QUEST_URL, $data);
        return json_decode($res, true);
    }

    //督察单告警推送模板
    public function SendDeviceAlarm1($access_token,$openid,$content,$type,$title,$people,$remark,$url){
        $data = array(
            "touser"=> $openid,
            "template_id"=>"KgnEEfYldiyqO71wTXzNZHCGk_cn_3hR0SAEydGFKpo",
            "url" =>$url,
            "data"=> array(
                "first"=> array(
                    "value"=> $content,
                    "color"=>"#44b549"
                ),
                "keyword1"=>array(
                    "value"=> $type,
                    "color"=>"#173177"
                ),
                "keyword2"=> array(
                    "value"=> $title,
                    "color"=>"#173177"
                ),
                "keyword3"=> array(
                    "value"=> $people,
                    "color"=>"#173177"
                ),
                "remark"=>array(
                    "value"=> $remark,
                    "color"=>"#173177"
                )
            )
        );
        $data = json_encode($data);
        $QUEST_URL = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=".$access_token;
        $res = $this->curl($QUEST_URL,$data);
        return json_decode($res,true);
    }


    /**
     * 日志打印
     * @param $Data 参数（数组）
     * @param $filename_log 日志储存地址
     * @param $type_name 设备类型名称
     * @param $customize 格式
     */
    public function printing_log($Data, $filename_log, $type_name, $customize)
    {
        $log = $type_name . "告警-" . $customize . "[时间" . date("Y-m-d H:i:s") . "]：" . json_encode($Data, JSON_UNESCAPED_UNICODE) . "\r\n";
        file_put_contents($filename_log, $log, FILE_APPEND | LOCK_EX);
    }

    public function getDeviceCode($Data)
    {
        if (!empty($Data['IMEI'])) {
            return $Data['IMEI'];
        } else if (!empty($Data['IEMI'])) {
            return $Data['IEMI'];
        } else if (!empty($Data['id'])) {
            return $Data['id'];
        } else if (!empty($Data['device_code'])) {
            return $Data['device_code'];
        } else {
            echo '设备编号不可为空';
            exit;
        }
    }


    /**
     * redis缓存逻辑
     * @param $device_code 设备编号
     * @param $dbindex 缓存库
     * @param $time 告警时间
     * @return int
     */
    public function redisLogic($device_code, $dbindex, $time)
    {
        $unique_number = $device_code;
        $redis = new \Redis();
        $result = $redis->connect('47.98.201.73', 6379);
        $redis->auth("usky2021");
        $redis->select($dbindex);
        if ($result == 1) {
            $unique_number_value = $redis->get("$unique_number");
            if (!empty($unique_number_value)) {
                if ($unique_number_value == 1) {
                    $redis->set("$unique_number", "$time");
                    return 1;
                } else {
                    if (floor((strtotime($time) - strtotime($unique_number_value)) / 3600) > 3) {
                        $redis->set("$unique_number", "$time");
                        return 1;
                    } else {
                        return 0;
                    }
                }
            } else {
                $redis->set("$unique_number", "$time");
                return 1;
            }
            $redis->close();
        } else {
            echo 'Redis连接失败';
            exit();
        }
    }

    /**
     * 告警报备和3H过滤机制
     * @param $company_code 单位编号
     * @param $dwtype 设备类型
     * @param $device_code 设备编号
     * @param $time 告警时间
     * @param $insert_id 告警ID
     * @param $unique_number 唯一编码
     */
    public function redisShieldAlarm($company_code,$dwtype,$device_code,$time,$insert_id,$unique_number){
        $redis = new \Redis();
        $result = $redis->connect('47.98.201.73', 6379);
        $redis->auth("usky2021");
        if ($result == 1){
            $redis->select(2);
            //redis单位判断
            $unique_code1 = $company_code . '_' . '000_000000000000000_0_00';
            $unique_code_value1 = $redis->get("$unique_code1");
            if (!empty($unique_code_value1)){
                $time_data1 = explode('_', $unique_code_value1);
                if (strtotime($time_data1[0])<=strtotime($time)&&strtotime($time_data1[1])>strtotime($time)){
                    echo "设备已报备，该告警不做推送";
                    exit();
                }
            }
            //redis类型判断
            $unique_code2 = $company_code . '_' . $dwtype.'_000000000000000_0_00';
            $unique_code_value2 = $redis->get("$unique_code2");
            if (!empty($unique_code_value2)){
                $time_data2 = explode('_', $unique_code_value2);
                if (strtotime($time_data2[0])<=strtotime($time)&&strtotime($time_data2[1])>strtotime($time)){
                    echo "设备已报备，该告警不做推送";
                    exit();
                }
            }

            //redis设备判断
            $unique_code3 = $company_code . '_' . $dwtype.'_'.$device_code.'_0_00';
            $unique_code_value3 = $redis->get("$unique_code3");
            if (!empty($unique_code_value3)){
                $time_data3 = explode('_', $unique_code_value3);
                if (strtotime($time_data3[0])<=strtotime($time)&&strtotime($time_data3[1])>strtotime($time)){
                    echo "设备已报备，该告警不做推送";
                    exit();
                }
            }

            //redis端口判断
            if ($dwtype==6){
                $where['id'] = $insert_id;
                $device_port_data = M("rtu2017")->where($where)->find();
                if ($device_port_data['port']=='E3'){
                    $port_type = 1;
                }else if ($device_port_data['port']=='E6'){
                    $port_type = 2;
                }
                $unique_code4 = $company_code . '_' . $dwtype.'_'.$device_code.'_'.$port_type.'_'.$device_port_data['ncmd'];
                $unique_code_value4 = $redis->get("$unique_code4");
                if (!empty($unique_code_value4)){
                    $time_data4 = explode('_', $unique_code_value4);
                    if (strtotime($time_data4[0])<=strtotime($time)&&strtotime($time_data4[1])>strtotime($time)){
                        echo "设备已报备，该告警不做推送";
                        exit();
                    }
                }
            }

            //3小时以内相同设备报警未处理则不推送
            if (!empty($unique_number)){
                $redis->select(5);
                $unique_number_value = $redis->get("$unique_number");
                if (!empty($unique_number_value)) {
                    if ($unique_number_value == 1) {
                        $redis->set("$unique_number", "$time");
                    } else {
                        if (floor((strtotime($time) - strtotime($unique_number_value)) / 3600) > 3) {
                            $redis->set("$unique_number", "$time");
                        } else {
                            $redis->close();
                            echo '3H内有相同告警，数据抛出不做告警';
                            exit();
                        }
                    }
                } else {
                    $redis->set("$unique_number", "$time");
                }
            }
            $redis->close();
        }else{
            echo 'Redis连接失败';
            exit();
        }
    }


    /**
     * 告警状态转化
     * @param $evt 状态编码
     * @return array
     */
    public function getAlarmStatus($evt)
    {
        $status_data = array();
        switch ($evt) {
            case 'y01':
                $status_data['status'] = '报警';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y02':
                $status_data['status'] = '报警静音';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y03':
            case 'y06':
                $status_data['status'] = '保留';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y04':
                $status_data['status'] = '低压';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y05':
                $status_data['status'] = '故障';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y07':
                $status_data['status'] = '火灾报警';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y08':
                $status_data['status'] = '温度报警';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y09':
                $status_data['status'] = '烟感电量低';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y10':
                $status_data['status'] = '防拆报警';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y11':
                $status_data['status'] = '发射电路故障';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'y12':
                $status_data['status'] = '设备自检';
                $status_data['where'] = " AND data2 like '%6%'";
                break;
            case 'ds02':
                $status_data['status'] = '门窗关闭';
                $status_data['where'] = '';
                break;
            case 'ds01':
                $status_data['status'] = '门窗开启';
                $status_data['where'] = '';
                break;
            case 'ds03':
            case 'GS02':
                $status_data['status'] = '电池电量低';
                $status_data['where'] = '';
                break;
            case 'WP1':
                $status_data['status'] = '低压';
                $status_data['where'] = " AND data2 like '%3%'";
                break;
            case 'WP2':
                $status_data['status'] = '高压';
                $status_data['where'] = " AND data2 like '%3%'";
                break;
            case 'WP3':
                $status_data['status'] = '故障';
                $status_data['where'] = " AND data2 like '%3%'";
                break;
            case 'LL1':
                $status_data['status'] = '低水位';
                $status_data['where'] = " AND data2 like '%3%'";
                break;
            case 'LL2':
                $status_data['status'] = '高水位';
                $status_data['where'] = " AND data2 like '%3%'";
                break;
            case 'EF1':
                $status_data['status'] = '欠压报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF2':
                $status_data['status'] = '过压报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF3':
                $status_data['status'] = '过流报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF4':
                $status_data['status'] = '漏电报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF5':
                $status_data['status'] = '回路1温度超限报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF6':
                $status_data['status'] = '回路2温度超限报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF7':
                $status_data['status'] = '回路3温度超限报警';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'EF8':
                $status_data['status'] = '温度4超高';
                $status_data['where'] = " AND data2 like '%7%'";
                break;
            case 'LL0':
                $status_data['status'] = '正常';
                $status_data['where'] = "";
                break;
            case 'LL1':
                $status_data['status'] = '低水位';
                $status_data['where'] = "";
                break;
            case 'LL2':
                $status_data['status'] = '高水位';
                $status_data['where'] = "";
                break;
            case 'LL3':
                $status_data['status'] = '故障';
                $status_data['where'] = "";
                break;
            case 'LL5':
                $status_data['status'] = '波动告警';
                $status_data['where'] = "";
                break;
            case 'H02P0':
                $status_data['status'] = '测试运行';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'H02P1':
            case 'U21P1':
                $status_data['status'] = '火警';
                $status_data['where'] = " AND data2 like '%1%'";
                break;
            case 'H02P2':
            case 'U21P2':
                $status_data['status'] = '故障';
                $status_data['where'] = " AND data2 like '%2%'";
                break;
            case 'H02P3':
                $status_data['status'] = '屏蔽';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'H02P4':
                $status_data['status'] = '监管';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'H02P5':
                $status_data['status'] = '启动';
                $status_data['where'] = " AND data2 like '%1%'";
                break;
            case 'H02P6':
                $status_data['status'] = '反馈';
                $status_data['where'] = " AND data2 like '%1%'";
                break;
            case 'H02P7':
                $status_data['status'] = '延时';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'H02P8':
                $status_data['status'] = '电源故障';
                $status_data['where'] = " AND data2 like '%2%'";
                break;
            case 'U24P0':
                $status_data['status'] = '复位';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U24P1':
                $status_data['status'] = '消音';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U24P2':
                $status_data['status'] = '手动报警';
                $status_data['where'] = " AND data2 like '%1%'";
                break;
            case 'U24P3':
                $status_data['status'] = '警情消除';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U24P4':
                $status_data['status'] = '自检';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U24P5':
                $status_data['status'] = '查岗应答';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U24P6':
                $status_data['status'] = '测试';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U21P0':
                $status_data['status'] = '正常';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U21P3':
                $status_data['status'] = '主电故障';
                $status_data['where'] = " AND data2 like '%2%'";
                break;
            case 'U21P4':
                $status_data['status'] = '备电故障';
                $status_data['where'] = " AND data2 like '%2%'";
                break;
            case 'U21P5':
                $status_data['status'] = '监控';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'U21P6':
                $status_data['status'] = '接线';
                $status_data['where'] = " AND data2 like '%0%'";
                break;
            case 'LF01':
                $status_data['status'] = '声音报警';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF03':
                $status_data['status'] = '电梯检修';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF04':
                $status_data['status'] = '电梯检修恢复';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF05':
                $status_data['status'] = '电梯故障';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF0501':
                $status_data['status'] = '电梯异常停留';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF0502':
                $status_data['status'] = '电梯异常开门';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF0503':
                $status_data['status'] = '电梯异常关门';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF0504':
                $status_data['status'] = '电梯异常走梯';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'LF06':
                $status_data['status'] = '电梯故障恢复';
                $status_data['where'] = " AND data2 like '%9%'";
                break;
            case 'gs01':
            case 'gs08':
                $status_data['status'] = '车位变空';
                $status_data['where'] = "";
                break;
            case 'gs02':
            case 'gs07':
                $status_data['status'] = '车位被占';
                $status_data['where'] = "";
                break;
            case 'gs03':
                $status_data['status'] = '强磁干扰';
                $status_data['where'] = "";
                break;
            case 'gs04':
                $status_data['status'] = '低电压报警';
                $status_data['where'] = "";
                break;
            case 'gs05':
                $status_data['status'] = '磁传感器检测失效';
                $status_data['where'] = "";
                break;
            case 'gs06':
                $status_data['status'] = '磁传感器硬件损坏';
                $status_data['where'] = "";
                break;
            case 'JG01':
                $status_data['status'] = '打开恢复';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'JG02':
                $status_data['status'] = '打开告警';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'JG03':
                $status_data['status'] = '角度传感器异常';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'JG04':
                $status_data['status'] = '温湿度传感器异常';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'JG06':
                $status_data['status'] = '满溢恢复';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'JG07':
                $status_data['status'] = '满溢告警';
                $status_data['where'] = " AND data2 like '%a%'";
                break;
            case 'GS01':
                $status_data['status'] = '可燃气体告警';
                $status_data['where'] = '';
                break;
            case 'GS03':
                $status_data['status'] = '设备防拆';
                $status_data['where'] = '';
                break;
            case '44':
            case 'LL4':
            case 'EF9':
            case 'WP4':
                $status_data['status'] = '离线';
                $status_data['where'] = " AND data2 like '%5%'";
                break;
            default:
                $status_data['status'] = '其他' . $evt;
                $status_data['where'] = "";
                break;
        }
        return $status_data;
    }



//    public function SendDeviceAlarm3($access_token,$openid,$address,$deviceid,$type,$time,$remark,$url){
//        $data = array(
//            "touser"=> $openid,
//            "template_id"=>"kMIOm99qgqAQ-nqsSxWlUToz4Krm-_TopRBJolXNBB8",
//            "url" =>$url,
//            //"url" =>"http://zt-iot.com/ztxf/weixin.php/Home/Fire/water",
//            "data"=> array(
//                "first"=> array(
//                    "value"=> $address,
//                    "color"=>"#44b549"
//                ),
//                "keyword1"=>array(
//                    "value"=> $deviceid,
//                    "color"=>"#173177"
//                ),
//                "keyword2"=> array(
//                    "value"=> $type,
//                    "color"=>"#173177"
//                ),
//                "keyword3"=> array(
//                    "value"=> $time,
//                    "color"=>"#173177"
//                ),
//                "remark"=>array(
//                    "value"=> $remark,
//                    "color"=>"#aaaaaa"
//                )
//            )
//        );
//        //{{first.DATA}}
//        //设备号：{{keyword1.DATA}}
//        //报警类型：{{keyword2.DATA}}
//        //时间：{{keyword3.DATA}}
//        //{{remark.DATA}}
//        $data = json_encode($data);
//        $QUEST_URL = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=".$access_token;
//        $res = $this->curl($QUEST_URL,$data);
//        return json_decode($res,true);
//    }
}